// EditSnd.h : header file
//

#define SOUNDTIMERID		5629		// identifiktor asovae

/////////////////////////////////////////////////////////////////////////////
// CEditSound dialog

class CEditSound : public CDialog
{
// Construction
public:
	CEditSound(CWnd* pParent = NULL);   // standard constructor
	~CEditSound();						// destruktor

// Dialog Data
	//{{AFX_DATA(CEditSound)
	enum { IDD = IDD_EDIT_SOUND };
	CStatic	m_Text60;
	CStatic	m_Text50;
	CStatic	m_Text40;
	CStatic	m_Text30;
	CStatic	m_Text20;
	CStatic	m_Text10;
	CStatic	m_Text0;
	CProgressCtrl	m_Progress;
	//}}AFX_DATA

	CSoundBuf*		m_Sound;			// buffer zvuk
	int				m_Index;			// index editovan poloky

	int				m_Mode;				// md
										//  0 = klid
										//  1 = pehrvn
										//  2 = nahrvn

	int				m_PlayCount;		// ta asu pro pehrvn
	int				m_PlayCount0;		// poten stav itae

	char*			m_Data;				// adresa bufferu
	int				m_DataMax;			// velikost bufferu
	int				m_DataNum;			// poet bajt v bufferu

	int				m_TimerID;			// ID asovae

	HWAVEIN			m_hWaveIn;			// handle vstupnho zazen
	WAVEFORMATEX	m_WaveFormat;		// popisova struktury formtu
	WAVEHDR			m_WaveHeader;		// popisova dat

	MMTIME			m_mmTime;			// struktura informac o nahrvn

	void BegEdit(int index);
	void Record();
	void Play();
	void Stop();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CEditSound)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL


// Implementation

	// Generated message map functions
	//{{AFX_MSG(CEditSound)
	afx_msg void OnClose();
	afx_msg void OnTimer(UINT nIDEvent);
	virtual BOOL OnInitDialog();
	afx_msg void OnSize(UINT nType, int cx, int cy);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};
