
/////////////////////////////////////////////////////////////////////////////
// zahjen taen

void CProg::OnBeginDragProgObj(NMHDR* pNMHDR, LRESULT* pResult) 
{	m_DragSrc = BufObjID;
	m_TreeSrc = &m_Object;
	OnBeginDragProg(pNMHDR, pResult); }

void CProg::OnBeginDragProgLoc(NMHDR* pNMHDR, LRESULT* pResult) 
{	m_DragSrc = BufLocID;
	m_TreeSrc = &m_Local;
	OnBeginDragProg(pNMHDR, pResult); }

void CProg::OnBeginDragProgStr(NMHDR* pNMHDR, LRESULT* pResult) 
{	m_DragSrc = BufStrID;
	m_TreeSrc = &m_Struc;
	OnBeginDragProg(pNMHDR, pResult); }

void CProg::OnBeginDragProgCls(NMHDR* pNMHDR, LRESULT* pResult) 
{	m_DragSrc = BufClsID;
	m_TreeSrc = &m_Class;
	OnBeginDragProg(pNMHDR, pResult); }

void CProg::OnBeginDragProgEdi(NMHDR* pNMHDR, LRESULT* pResult) 
{	m_DragSrc = BufEdiID;
	m_TreeSrc = &m_Edit;
	OnBeginDragProg(pNMHDR, pResult); }

void CProg::OnBeginDragProg(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_TREEVIEW*	pnm = (NM_TREEVIEW*)pNMHDR; // notifikan zprva
	CPoint			pt; 				// souadnice kurzoru myi na obrazovce
	UINT			nFlags; 			// pznaky, kam bylo kliknuto
	RECT			rect;				// naten souadnice textu prvku
	int 			width, height;		// zjitn velikost ikon stromu

// nesm probhat taen
	*pResult = 0;
	if (m_Dragging) return;

// pprava taenho a clovho prvku
	m_itemDrag = m_TreeSrc->HitTest(pnm->ptDrag, &nFlags);
	if (m_itemDrag == NULL) return;
	m_itemDragN = m_Buf[m_DragSrc].SrcItem(m_itemDrag);
	if (m_itemDragN == -1) return;
	m_itemDragPar = m_Buf[m_DragSrc].m_Items[m_itemDragN].param;
	m_itemDragModel = m_Buf[m_DragSrc].m_Items[m_itemDragN].model;
	m_itemDrop = NULL;

// zakzan prvek pro taen
	if ((m_itemDragPar & (PR_NOMOVE | PR_LOCK | PR_LOCK_DEP)) != 0) return;

// zjtn souadnic textu prvku
	if(!m_TreeSrc->GetItemRect(m_itemDrag,&rect,TRUE)) return;

// zjitn velikosti ikony ve stromu
	ImageList_GetIconSize(
		m_TreeSrc->GetImageList(TVSIL_NORMAL)->m_hImageList,
		&width, 
		&height);

// vpoet vzdlenosti kurzoru myi od potku prvku
	m_HotSpot = CPoint(pnm->ptDrag) - CPoint(rect.left-width-3, rect.top);
	m_TestSpot = CSize(width/2, 0);

// pprava seznamu obrzk taen
	m_DragList = m_TreeSrc->CreateDragImage(m_itemDrag);
	if (m_DragList == NULL) return;

// nastaven pznaku zahjen taen (te ji se nesm peruit)
	m_Dragging = TRUE;
	m_TreeDst = NULL;
	m_DropIndex = -1;
//	m_DropParent = -1;

// vbr clovho prvku
	m_TreeSrc->SelectDropTarget(m_itemDrag);

// zapnut zobrazen obrzku taen (bez uzamykn okna)
	m_DragList->DragShowNolock(TRUE);

// rozlien mdu pesunu nebo kopie podle tlatek myi
	if (pnm->hdr.code == TVN_BEGINRDRAG)	// je prav tlatko ?
		m_DragRight = TRUE; 				// je prav tlatko
	else
		m_DragRight = FALSE;				// nen prav tlatko

// korekce, kter prvky budou vdy jen koprovny
	m_DragLeftInt = FALSE;					// nen lev tlatko + intern prvek
	if (m_itemDragPar & PR_INTERNAL)
	{
		if (m_DragRight == FALSE)
		{
			m_DragLeftInt = TRUE;			// lev tlatko + intern prvek
		}
		m_DragRight = TRUE;
	}

// pprava pznaku koprovn
	m_DragCopy = TRUE;						// bude se koprovat
	m_DragDelete =	!m_DragRight;			// ru se pi pesunu levm tlatkem

// zapnut kurzoru pro taen
//	m_OldCursor = ::GetCursor();
	if (m_DragRight)
		m_CurAkt = m_CurCopy;
	else
		m_CurAkt = m_CurMove;
	::SetCursor(m_CurAkt);

// vytvoen novho obrzku taen
	m_DragList->SetDragCursorImage(0, CPoint(m_HotSpot));

// zahjen operace taen
	m_DragList->BeginDrag(0, CPoint(0,0));

// naten souadnic kurzoru myi
	GetCursorPos(&pt);

// pro strom struktur zruen vbru cle
//	if (m_DragSrc == BufStrID)
	m_TreeSrc->SelectDropTarget(NULL);

// zahjen operace taen, zkaz aktualizace okna
	m_DragList->DragEnter(NULL, pt - m_HotSpot);

// petaen obrzku na aktuln pozici myi
	m_DragList->DragMove(pt - m_HotSpot);

// zahjen zachytvn myi
	SetCapture();
}

/////////////////////////////////////////////////////////////////////////////
// posun my pi taen

void CProg::OnMouseMove(UINT nFlags, CPoint point) 
{
	UINT		flags;				// pznaky clovho prvku
	HCURSOR 	hCurNew = m_CurNoDrag; // nov kurzor myi
	CPoint		ptScreen, ptTree;	// pozice taen ikony na obrazovce a ve stromu
	CTreeCtrl*	OldTree;			// pvodn clov strom
	int 		OldItem;			// pvodn vybran poloka
	CRect		rect;				// souadnice prvku pod kurzorem
	int 		width, height;		// zjitn velikost ikon stromu
	UINT		indent; 			// odsazovn poloek v clovm stromu
	int 		AlterDstN;			// alternativn cl poloen


	m_ProgMap.m_X = -1;
	m_ProgMap.m_Y = -1;

// obsluha taen pedlu
	if (m_Tracking)
		MoveTrack(point);
	else

// mus probhat taen
	if (m_Dragging)
	{
// pednastaven neplatnho cle operace
		OldTree = m_TreeDst;		// schova pvodnho clovho stromu
		OldItem = m_itemDropN;		// schova pvodn clov poloky
		m_TreeDst = NULL;			// nen clov strom
		m_DragDst = -1; 			// ID clovho stromu - nen
		m_itemDrop = NULL;			// nen clov poloka
		m_itemDropN = -1;			// nen clov poloka
		m_DropIndex = -1;			// zkaz uloen
		m_DragCopy = FALSE; 		// nen koprovn
		m_DragDelete = FALSE;		// nen ruen

// petaen obrzku na novou pozici
		ptScreen = point - m_HotSpot;
		ClientToScreen(&ptScreen);
		m_DragList->DragMove(ptScreen);

// nalezen okna, nad kterm je taeno
		if ((SrcDropWin(point)) || (SrcDropWin(CPoint(point.x, point.y + 32))))
		{

// taen do okna editoru mapy
			if (m_DragDst == BufMapID)
			{
				CPoint pt2 = point - m_HotSpot + m_TestSpot + CPoint(0,m_ProgMap.m_IconHeight/2);
				ClientToScreen(&pt2);
				m_ProgMap.ScreenToClient(&pt2);
				m_ProgMap.OnMouseMove(nFlags, pt2);
				if ((m_ProgMap.m_X != -1) &&
					(m_ProgMap.m_Y != -1))
					hCurNew = m_CurCopy;
			}
			else

// taen do okna editoru sprajt
			if (m_DragDst == BufSprID)
			{
				CPoint pt2 = point - m_HotSpot + m_TestSpot + CPoint(0,m_ProgSprite.m_IconHeight/2);
				ClientToScreen(&pt2);
				m_ProgSprite.ScreenToClient(&pt2);
				m_ProgSprite.OnMouseMove(nFlags, pt2);
				if ((m_ProgSprite.m_X != -1) &&
					(m_ProgSprite.m_Y != -1))
					hCurNew = m_CurCopy;
			}
			else

// pi taen do okna struktur bude odhozen
			if ((m_DragDst == BufStrID) && 
				(m_DragSrc != BufStrID) &&
				!m_DragRight
				)
			{
				m_DragDelete = TRUE;
				hCurNew = m_CurDelete;
			}

			else

// test, zda je taen pro clov okno platn
//			if (TestDropWin())
			{			
	
// nastaven pznak mdu kopie nebo pesunu
				m_DragCopy = TRUE;
				if (m_DragRight || (m_DragDst != m_DragSrc) ||
					((m_DragDst == BufClsID) && (m_DragSrc == BufClsID)))
					m_DragDelete = FALSE;
				else
					m_DragDelete = TRUE;

// pprava kurzoru pro koprovn nebo pesun
				if (m_DragDelete)
					hCurNew = m_CurMove;
				else
					hCurNew = m_CurCopy;

// pepoet stedu taen ikony na klientsk souadnice
				ptTree = ptScreen + m_TestSpot;
				m_TreeDst->ScreenToClient(&ptTree);

// nalezen clov poloky pod kurzorem
				m_itemDrop = m_TreeDst->HitTest(ptTree, &flags);
				m_itemDropN = m_Buf[m_DragDst].SrcItem(m_itemDrop);

// korekce, je-li taen nad prvn poloku v okn (vhodn pouze pro editan okno)
				if ((m_itemDropN == -1) && (ptTree.y <= 0) && (m_Buf[m_DragDst].m_Num > 0))
				{
					m_itemDropN = m_Buf[m_DragDst].m_First - 1;	// bude to prvn poloka
					if (m_itemDropN >= 0)
					{
						m_itemDrop = m_Buf[m_DragDst].m_Items[m_itemDropN].htree;
					}
				}

// pprava indexu k uloen poloky
				if (m_itemDropN == -1)
				{
					if (TestDropItem(m_itemDragModel, m_itemDragPar,
							m_DragSrc, TYP_ROOT, PR_GET_COMMAND, m_DragDst, m_itemDragN, m_itemDropN))
					{
						m_DropIndex = m_Buf[m_DragDst].m_Next;
					}
					else
					{
						m_itemDrop = NULL;
						m_DropIndex = -1;
						hCurNew = m_CurNoDrag;
						m_DragCopy = FALSE;
						m_DragDelete = FALSE;
					}
				}
				else
				{
					m_DropIndex = m_itemDropN+1;

// zjitn velikosti ikony v clovm stromu
					ImageList_GetIconSize(
						m_TreeDst->GetImageList(TVSIL_NORMAL)->m_hImageList,
						&width, 
						&height);

// zjitn odsazovn potomk
					indent = m_TreeDst->GetIndent();

// zjitn pozice prvku pod kurzorem
					m_TreeDst->GetItemRect(m_itemDrop, &rect, TRUE);

// vpoet stedu X ikony pod kurzorem
					rect.left = rect.left - width/2 + width/10;

// pprava alternativnho clovho prvku
					AlterDstN = m_Buf[m_DragDst].m_Items[m_itemDropN].parent;

// zjitn rodie podle X polohy kurzoru
					while ((ptTree.x < rect.left) && (m_itemDropN != -1))
					{
						AlterDstN = m_itemDropN;
						m_itemDropN = m_Buf[m_DragDst].m_Items[m_itemDropN].parent;
						if (m_itemDropN != -1)
							m_itemDrop = m_Buf[m_DragDst].m_Items[m_itemDropN].htree;
						else
							m_itemDrop = NULL;
						rect.left -= indent;
					}

// hlavn prvek -1 je povolen, alternativn tehdy nen = -1
					if (m_itemDropN != -1)
					{

// naten parametr hlavnho clovho prvku
						m_itemDrop = m_Buf[m_DragDst].m_Items[m_itemDropN].htree;
						m_itemDropPar = m_Buf[m_DragDst].m_Items[m_itemDropN].param;
						m_itemDropModel = m_Buf[m_DragDst].m_Items[m_itemDropN].model;

// est hlavnho clovho prvku
						if (!TestDropItem(m_itemDragModel, m_itemDragPar, m_DragSrc,
							m_itemDropModel, m_itemDropPar, m_DragDst, m_itemDragN, m_itemDropN))
						{

// jinak zmna na vedlej clov prvek
							m_itemDropN = AlterDstN;

// naten parametr vedlejho clovho prvku (neme bt = -1)
							m_itemDrop = m_Buf[m_DragDst].m_Items[m_itemDropN].htree;
							m_itemDropPar = m_Buf[m_DragDst].m_Items[m_itemDropN].param;
							m_itemDropModel = m_Buf[m_DragDst].m_Items[m_itemDropN].model;

// est vedlejho clovho prvku
							if (!TestDropItem(m_itemDragModel, m_itemDragPar, m_DragSrc,
							m_itemDropModel, m_itemDropPar, m_DragDst, m_itemDragN, m_itemDropN))
							{
								hCurNew = m_CurNoDrag;
								m_DropIndex = -1;
								m_DragCopy = FALSE;
								m_DragDelete = FALSE;
								m_itemDropN = -1;
								m_itemDrop = NULL;
							}
						}
					} // if (m_itemDropN != -1)
				} // m_itemDropN != -1

// test, zda je operace platn
				if (m_DropIndex != -1)
				{

// kontrola, zda nen cyklick koprovn uvnit okna
					if (m_DragDst == m_DragSrc)
					{
						int xitem = m_itemDropN;

						if ((m_DragSrc != BufClsID) && (m_DragDst != BufClsID))
							while ((xitem >= 0) && (xitem < m_Buf[m_DragDst].m_Num))
								if (xitem == m_itemDragN)
								{
									hCurNew = m_CurNoDrag;
									m_itemDropN = -1;
									m_DropIndex = -1;
									xitem = -1;
									m_DragCopy = FALSE;
									m_itemDrop = NULL;
									m_DragDelete = FALSE;
								}
								else
									xitem = m_Buf[m_DragDst].m_Items[xitem].parent;
					}

// upesnn indexu a cle, je-li hozen za konec stromu
					if (m_itemDropN == -1)
					{
						if (m_Buf[m_DragDst].m_First > 0)
						{
							m_itemDropN = m_Buf[m_DragDst].m_First - 1;
							m_itemDrop = NULL; //m_Buf[m_DragDst].m_Items[m_itemDropN].htree;
						}
						else
						{
							m_itemDrop = NULL;
						}
					}
					else
						m_itemDrop = m_Buf[m_DragDst].m_Items[m_itemDropN].htree;

					if (/*m_itemDrop == NULL*/ m_itemDropN == -1)
					{
						m_itemDropModel = TYP_ROOT;
						m_itemDropPar = PR_GET_COMMAND;
					}
					else
					{
						if ((m_DragDst == BufLocID) && (m_itemDropN == (m_Buf[m_DragDst].m_First-1)))
							m_itemDropModel = TYP_ROOT;
						else
							m_itemDropModel = m_Buf[m_DragDst].m_Items[m_itemDropN].model;
						m_itemDropPar = m_Buf[m_DragDst].m_Items[m_itemDropN].param;
					}

					if (!TestDropItem(m_itemDragModel, m_itemDragPar,
							m_DragSrc, m_itemDropModel, m_itemDropPar, m_DragDst, m_itemDragN, m_itemDropN))
					{
						m_DropIndex = -1;
						hCurNew = m_CurNoDrag;
						m_DragCopy = FALSE;
						m_itemDrop = NULL;
						m_itemDropN = -1;
						m_DragDelete = FALSE;
					}

				} // if(m_DropIndex != -1)
			} // if(TestDropWin())
		} // if(SrcDropWin(point))

// nastaven novho kurzoru myi
		if (hCurNew != m_CurAkt)
		{
			m_CurAkt = hCurNew;
			::SetCursor(m_CurAkt);
		}

// zruen vbru star clov poloky pi zmn okna stromu
		if ((OldTree != NULL) && (OldTree != m_TreeDst))
		{
			m_DragList->DragLeave(NULL);
			OldTree->SelectDropTarget(NULL);
			m_DragList->DragEnter(NULL, ptScreen);
		}

// vbr nov clov poloky
		if (((m_itemDropN != OldItem) || (OldTree != m_TreeDst))
			&& (m_TreeDst != NULL))
		{
			m_DragList->DragLeave(NULL);
			m_TreeDst->SelectDropTarget(m_itemDrop);
			m_DragList->DragEnter(NULL, ptScreen);
		}

	} // if(m_Dragging)

	if (!m_Dragging && m_ProgMap.m_Draging)
	{
		if (m_ProgMap.m_Copy)
			::SetCursor(m_ProgMap.m_CurNoDrag);
		else
			::SetCursor(m_ProgMap.m_CurDelete);
	}

	CFormView::OnMouseMove(nFlags, point);
}

/////////////////////////////////////////////////////////////////////////////
// nalezen clovho okna pod kurzorem myi pi taen

BOOL CProg::SrcDropWin(CPoint point)
{
// pednastaven neplatn operace
	m_TreeDst = NULL;
	m_DragDst = -1;

// nalezen okna, nad kterm je taeno
	CWnd* wnd = ChildWindowFromPoint(point - m_HotSpot + m_TestSpot,
					CWP_SKIPINVISIBLE | CWP_SKIPDISABLED);
	if (wnd == NULL) return FALSE;
	HWND hwnd = wnd->m_hWnd;

// pi taen internho prvku levm tlatkem zkaz stejnho okna
	if (m_DragLeftInt)
	{
		if (hwnd == m_TreeSrc->m_hWnd)
			return FALSE;
	}

// test okna veejnch objekt
	if (hwnd == m_Object.m_hWnd)
	{
		m_TreeDst = &m_Object;
		m_DragDst = BufObjID;
		return TRUE;
	}

// test okna loklnch objekt
	if (hwnd == m_Local.m_hWnd)
	{
		m_TreeDst = &m_Local;
		m_DragDst = BufLocID;
		return TRUE;
	}

// test okna struktur
	if (hwnd == m_Struc.m_hWnd)
	{
		m_TreeDst = &m_Struc;
		m_DragDst = BufStrID;
		return TRUE;
	}

// test okna td
	if (hwnd == m_Class.m_hWnd)
	{
		m_TreeDst = &m_Class;
		m_DragDst = BufClsID;
		return TRUE;
	}

// test okna editace
	if (hwnd == m_Edit.m_hWnd)
	{
		m_TreeDst = &m_Edit;
		m_DragDst = BufEdiID;
		return TRUE;
	}

// okno mapy
	if ((hwnd == m_ProgMap.m_hWnd) &&
		((m_DragSrc == BufObjID) ||
		(m_DragSrc == BufLocID)) &&
		((m_itemDragModel == TYP_PIC) || (m_itemDragModel == TYP_NONE)))
	{
		m_DragDst = BufMapID;
		return TRUE;
	}

// okno sprajt
	if ((hwnd == m_ProgSprite.m_hWnd) &&
		((m_DragSrc == BufObjID) ||
		(m_DragSrc == BufLocID)) &&
		((m_itemDragModel == TYP_PIC) || (m_itemDragModel == TYP_NONE)))
	{
		m_DragDst = BufSprID;
		return TRUE;
	}

// okno nenalezeno
	return FALSE;
}

/////////////////////////////////////////////////////////////////////////////
// test povolen spojen dvou prvk

BOOL CProg::TestDropItem(int srcModel, int srcPar, int srcBuff, int dstModel,
						 int dstPar, int dstBuff, int srcItem, int dstItem)
{
	if (dstPar & (PR_LOCK | PR_LOCK_DEP))			// prvek chrnn proti modifikaci
		return FALSE;

	switch (dstBuff)
	{
///////////////////////// clem okno objekt
	case BufObjID:
		if (srcBuff == BufEdiID) return FALSE;		// z editoru nelze nikdy thnout

		if (srcBuff == BufLocID) return FALSE;		// z loklnch objekt nelze nikdy thnout

		if ((dstModel == TYP_LIST_SIZE) &&			// petaen slice do rozmru seznamu
			(srcModel == TYP_CIS))
			return TRUE;

		if ((srcBuff == BufStrID) && 
			(srcModel != TYP_GROUP) && 
			(srcModel != TYP_LIST)) return FALSE;	// z okna struktur jen skupinu a seznam

		if (dstModel == TYP_LIST)					// clem seznam objekt
		{
			switch (srcModel)
			{
			case TYP_REAL:
			case TYP_BOOL:
			case TYP_TEXT:
			case TYP_PIC:
			case TYP_NONE:
			case TYP_MAP:
			case TYP_BACK:
			case TYP_SND:
			case TYP_MUS:
			case TYP_SPRITE:
			case TYP_DIALOG:
			case TYP_CLASS:
				return TRUE;
			}
			return FALSE;
		}

		if ((dstModel != TYP_GROUP) &&				// clem jen skupina nebo ROOT
			(dstModel != TYP_ROOT)) return FALSE;

		switch (srcModel)
		{
		case TYP_GROUP:
		case TYP_LIST:
		case TYP_FUNC:
		case TYP_REAL:
		case TYP_BOOL:
		case TYP_TEXT:
		case TYP_PIC:
		case TYP_NONE:
		case TYP_MAP:
		case TYP_BACK:
		case TYP_SND:
		case TYP_MUS:
		case TYP_SPRITE:
		case TYP_DIALOG:
		case TYP_EVENT:
		case TYP_CLASS:
			return TRUE;
		}
		return FALSE;

////////////////////////// clem okno editoru
	case BufEdiID:

// slici nelze pethnout do ROOT rovn (pro je nastaveno PR_GET_EXPRES ?!?!?!)
		if ((srcModel == TYP_CIS) && (dstModel == TYP_FUNC))
			return FALSE;

// z td nelze nikdy thnout
		if (srcBuff == BufClsID) return FALSE;

// skupinu objekt nelze thnout
		if (((srcBuff == BufObjID) || (srcBuff == BufLocID)) && 
			(srcModel == TYP_GROUP)) return FALSE;

// seznam objekt nen povolen nikdy
		if (srcModel == TYP_LIST)
			return FALSE;

// z okna objekt nen povolena slice (z velikosti seznamu)
		if (((srcBuff == BufObjID) || (srcBuff == BufLocID)) &&
			(srcModel == TYP_CIS))
			return FALSE;

// test, zda je povolen pouze jeden parametr
		if (((dstPar & PR_ONE) != 0) && (dstItem != -1))
		{
			if (m_Buf[dstBuff].m_Items[dstItem].items > 1)
			{
				return FALSE;
			}
		}

// petaen pkazu
		if (((srcPar & PR_AS_COMMAND) != 0) &&
			((dstPar & PR_GET_COMMAND) != 0)) return TRUE;

// petaen vrazu
		if (((srcPar & PR_AS_EXPRES) != 0) &&
			((dstPar & PR_GET_EXPRES) != 0)) return TRUE;

// petaen logickho vrazu
		if (((srcPar & PR_AS_BOOL) != 0) &&
			((dstPar & PR_GET_BOOL) != 0)) return TRUE;

// petaen zvuku
		if (srcModel == TYP_SND)
		{
			if ((dstModel == TYP_SND) ||
				(dstModel == TYP_SOUND_PLAY))
				return TRUE;
			else
				return FALSE;
		}

// petaen vtve CASE
		if (srcModel == TYP_CASE_ON)
		{
			if (dstModel == TYP_CASE)
				return TRUE;
			else
				return FALSE;
		}

// petaen funkce
		if (srcModel == TYP_FUNC)
		{
			switch (dstModel)
			{
			case TYP_TEXT:
			case TYP_PIC:
			case TYP_NONE:
			case TYP_MAP:
			case TYP_BACK:
			case TYP_SND:
			case TYP_MUS:
			case TYP_SPRITE:
			case TYP_DIALOG:
			case TYP_EVENT:
			case TYP_CLASS:
			case TYP_EQU_TEXT:
			case TYP_EQU_PIC:
			case TYP_TXT_TXT:
			case TYP_TXT_SUB:
			case TYP_FNT:
			case TYP_FTT:
				return TRUE;
			}
			return FALSE;
		}

// petaen testu vtve CASE
		if (srcModel == TYP_CASE_TEST)
		{
			if (dstModel == TYP_CASE_ON)
				return TRUE;
			else
				return FALSE;
		}

// petaen slice do seln konstanty
		if (dstModel == TYP_NUM)
		{
			switch (srcModel)
			{
			case TYP_CIS:
			case TYP_TECKA:
			case TYP_MINUS:
			case TYP_EXPONENT:
				return TRUE;
			}
			return FALSE;
		}

// petaen textu
		switch (srcModel)
		{
		case TYP_FTN:
		case TYP_FT:
		case TYP_TXT:
		case TYP_FTT:
		case TYP_FTNT:
		case TYP_TEXT:
			switch (dstModel)
			{
			case TYP_FTT:
			case TYP_FTNT:
			case TYP_FNT:
			case TYP_TEXT:
			case TYP_EQU_TEXT:
			case TYP_CASE_EXPR:
			case TYP_CASE_TEST:
			case TYP_TXT_TXT:
			case TYP_TXT_SUB:
				return TRUE;
			}
			return FALSE;
		}

// petaen okraje
		if ((srcModel == TYP_OKRAJ))
		{
			if ((dstModel == TYP_CASE_EXPR) ||
				(dstModel == TYP_PIC) ||
				(dstModel == TYP_CASE_TEST) ||
				(dstModel == TYP_EQU_PIC))
				return TRUE;
			else
				return FALSE;
		}

// petaen obrzku
		if ((srcModel == TYP_PIC) || (srcModel == TYP_NONE))
		{
			if ((dstModel == TYP_PIC) ||
				(dstModel == TYP_NONE) ||
				(dstModel == TYP_CASE_EXPR) ||
				(dstModel == TYP_CASE_TEST) ||
				(dstModel == TYP_EQU_PIC))
				return TRUE;
			else
				return FALSE;
		}

// petaen promnn
		switch (srcModel)
		{
		case TYP_TEXT:
		case TYP_PIC:
		case TYP_NONE:
		case TYP_MAP:
		case TYP_BACK:
		case TYP_SND:
		case TYP_MUS:
		case TYP_SPRITE:
		case TYP_DIALOG:
		case TYP_EVENT:
		case TYP_CLASS:
			if ((srcModel == dstModel) ||
				(dstModel == TYP_CASE_EXPR) ||
				(dstModel == TYP_CASE_TEST) ||
				((srcModel == TYP_NONE) && (dstModel == TYP_PIC)) ||
				((srcModel == TYP_PIC) && (dstModel == TYP_NONE)))
				return TRUE;
			else
				return FALSE;
		}

		return FALSE;

////////////////////////// clem okno loklnch objekt
// zablokovat vytvoen skupiny v parametrech funkce i objektu!

	case BufLocID:
		if (srcBuff == BufEdiID) return FALSE;		// z editoru nelze nikdy thnout

		if (srcBuff == BufObjID) return FALSE;		// z objekt nelze nikdy thnout

		if ((dstModel == TYP_LIST_SIZE) &&			// petaen slice do rozmru seznamu
			(srcModel == TYP_CIS))
			return TRUE;

		if ((srcBuff == BufStrID) && 
			(srcModel != TYP_GROUP) && 
			(srcModel != TYP_LIST)) return FALSE;	// z okna struktur jen skupinu a seznam

		if (dstModel == TYP_LIST)					// clem seznam objekt
		{
			switch (srcModel)
			{
			case TYP_REAL:
			case TYP_BOOL:
			case TYP_TEXT:
			case TYP_PIC:
			case TYP_NONE:
			case TYP_MAP:
			case TYP_BACK:
			case TYP_SND:
			case TYP_MUS:
			case TYP_SPRITE:
			case TYP_DIALOG:
			case TYP_CLASS:
				return TRUE;
			}
			return FALSE;
		}

		if ((dstModel != TYP_GROUP) &&				// clem jen skupina, ROOT nebo parametr
			(dstModel != TYP_ROOT) &&
			(dstModel != TYP_PROPERTIES) &&
			(dstModel != TYP_IPARAM) &&
			(dstModel != TYP_OPARAM)) return FALSE;

// skupinu ani seznam nelze umstit do vstupnch i vstupnch parametr
		if (((srcModel == TYP_GROUP) || (srcModel == TYP_LIST)) &&
			((dstModel == TYP_IPARAM) || (dstModel == TYP_OPARAM)))
			return FALSE;


// test, zda je povolen pouze jeden parametr
		if (((dstPar & PR_ONE) != 0) && (dstItem != -1))
		{
			if (m_Buf[dstBuff].m_Items[dstItem].items > 1)
			{
				return FALSE;
			}
		}

		switch (srcModel)
		{
		case TYP_GROUP:
		case TYP_LIST:
		case TYP_FUNC:
		case TYP_REAL:
		case TYP_BOOL:
		case TYP_TEXT:
		case TYP_PIC:
		case TYP_NONE:
		case TYP_MAP:
		case TYP_BACK:
		case TYP_SND:
		case TYP_MUS:
		case TYP_SPRITE:
		case TYP_DIALOG:
		case TYP_EVENT:
		case TYP_CLASS:
			return TRUE;
		}
		return FALSE;

////////////////////////// clem okno td - nelze thnout
//	case BufClsID:
//		if ((srcBuff == BufStrID) && (srcModel == TYP_GROUP)) // kopie skupiny ze struktur
//			return TRUE;

//		if (srcBuff != BufClsID)
//			return FALSE;							// z jinch oken nelze thnout

//		if ((srcModel == TYP_FUNC) || (srcModel == TYP_EVENT))
//		if ((srcModel != TYP_CLASS) || (dstModel != TYP_CLASS))
//			return FALSE;							// funkci ani udlost nelze ddit

//		if (srcModel != dstModel)					// mus bt stejn model
//			return FALSE;

//		if (m_Buf[srcBuff].m_Items[srcItem].parent == // stejn rodi je OK
//			dstItem)
//			return TRUE;

//		if (srcItem == dstItem)						// bude vlastn potomek
//			return TRUE;

//		return FALSE;
	}
	return FALSE;
}

/////////////////////////////////////////////////////////////////////////////
// ukonen taen uvolnnm tlatka myi

void CProg::OnLButtonUp(UINT nFlags, CPoint point) 
{
	if (m_Tracking)
		EndTrack();
	else
		OnButtonUp();	
	CFormView::OnLButtonUp(nFlags, point);
}

void CProg::OnRButtonUp(UINT nFlags, CPoint point) 
{
	OnButtonUp();
	CFormView::OnRButtonUp(nFlags, point);
}

void CProg::OnButtonUp()
{
// test, zda probh taen
	if (m_Dragging)
	{
// ukonen pznaku taen
		m_Dragging = FALSE;

// pozastaven taen
		m_DragList->DragLeave(NULL);

// ukonen taen
		m_DragList->EndDrag();

// zruen seznamu obrzk taen
		delete m_DragList;
		m_DragList = NULL;

// zruen vbru cle operace u clovho okna
		if (m_TreeDst != NULL)
			m_TreeDst->SelectDropTarget(NULL);

// uvolnn zachytvn myi
		ReleaseCapture();

// zruen pekreslen clovho prvku
		::SetCursor(m_CurArrow /*m_OldCursor*/);

		if (m_DragCopy || m_DragDelete)
		{

			int mode = 1;
			if (m_DragCopy) mode = 0;
			if (m_DragDelete) mode++;

			DragItem(m_DragSrc, m_itemDragN, m_DragDst, m_DropIndex, m_itemDropN, mode);

			UpdateLock();
		}
		else
		{
			if ((m_DragDst == BufMapID) &&
				(m_ProgMap.m_X != -1) &&
				(m_ProgMap.m_Y != -1))
			{
				m_ProgMap.DragDrop(m_Buf[m_DragSrc].GetIcon(m_itemDragN));
			}

			if ((m_DragDst == BufSprID) &&
				(m_ProgSprite.m_X != -1) &&
				(m_ProgSprite.m_Y != -1))
			{
				m_ProgSprite.DragDrop(m_Buf[m_DragSrc].GetIcon(m_itemDragN));
			}
		}

		DispName();

		if (m_EditBufN == BufMapID)
			m_ProgMap.Invalidate(FALSE);

		if (m_EditBufN == BufSprID)
			m_ProgSprite.Invalidate(FALSE);
	}
}


/////////////////////////////////////////////////////////////////////////////
// kopie, petaen nebo odhozen poloky
//
// parametry:
//		srcID	- zdrojov buffer
//		src		- zdrojov index
//		dstID	- clov buffer
//		dst		- clov index
//		parent	- index rodie v clovm bufferu
//		mode	- md operace (0 = kopie, 1 = pesun, 2 = zruen)
//
// vrac nov index clov poloky
//
// pi petaen na mst se nic neprovede
// na petaenou poloku se zam fokus

int CProg::DragItem(int srcID, int src, int dstID, int dst, int parent, int mode)
{
// proveden kopie, pesunu nebo zruen poloky
	switch (mode)
	{
	case 0:											// kopie
		dst = m_Buf[dstID].Copy(dst, parent, srcID, src);
		if ((srcID == dstID) &&	(dst < src))		// je clov poloka ped zdrojovou ?
			src += m_Buf[dstID].m_Items[dst].items;	// oprava indexu zdrojov poloky
		break;

	case 1:											// pesun
		dst = m_Buf[dstID].MoveTre(dst, parent, src);
		break;

	case 2:
		m_Buf[srcID].DeleteTre(src);				// zruen poloky
		break;
	}

// zajitn viditelnosti
	if ((mode <= 1) && (m_Buf[dstID].m_Tree != NULL))
		m_Buf[dstID].m_Tree->EnsureVisible(m_Buf[dstID].m_Items[dst].htree);

// pepnut na vloenou poloku funkce (je to potebn i pi koprovn v jednom okn !)
	if ((mode == 0) &&
		(m_Buf[dstID].m_Items[dst].model == TYP_FUNC))
	{

		if (dstID == BufLocID)						// je clem okno loklnch objekt ?
			DblclkLocal(dst);						// aktualizace loklnch objekt

		if (dstID == BufObjID)						// je clem okno globlnch objekt ?
			DblclkObject(dst);						// aktualizace globlnch objekt
	}

	m_BufLoc.SetFirst(m_BufLoc.m_First-1);
	m_BufEdi.SetFirst(m_BufEdi.m_First-1);

	AktAllDef();								// aktualizace defininch ukazatel

// navrcen indexu clov poloky
	return dst;						// nov index clov poloky
}


