
////////////////////////////////////////////////////////////////////
// tda bufferu sel

////////////////////////////////////////////////////////////////////
// Poznmka - pi kopii a pesunu struktur se vytv nov poloky
//            sel, star se nechaj se na mst.
////////////////////////////////////////////////////////////////////

class CRealBuf : public CObject
{
public:
// konstruktor a destruktor
	CRealBuf();
	virtual ~CRealBuf();

// data
	double* m_Data;			// ukazatel na data
	int m_Num;				// poet prvk
	int m_Max;				// maximln velikost bufferu

// zjitn potu poloek v bufferu
	inline int GetSize() const 
		{ return m_Num; }

// nastaven nov velikosti bufferu
	void SetSize(int nNewSize);

// poskytnut poloky na dan pozici
	inline double Get(int nIndex) const
		{ 
			if (nIndex < 0 || nIndex >= m_Num)
				return 0;
			else
				return m_Data[nIndex]; 
		}

// nastaven poloky na dan pozici
	inline void Set(int nIndex, double newElement)
		{
			if (nIndex >= 0 && nIndex < m_Num)
				m_Data[nIndex] = newElement;
		}

// pstup k poloce pole
	inline double& operator[] (int nIndex)
		{ 
			ASSERT(nIndex >= 0 && nIndex < m_Num);
			return m_Data[nIndex]; 
		}

// pidn poloky na konec pole
	inline int Add(double newElement)
		{
			SetSize(m_Num+1);
			m_Data[m_Num-1] = newElement;
			return m_Num-1;
		}

// duplikace poloky (vrac index nov poloky)
	inline int Duplik(int index)
	{
		SetSize(m_Num+1);
		m_Data[m_Num-1] = Get(index);
		return m_Num-1;
	}

// vyprzdnn celho bufferu
	inline void RemoveAll() { SetSize(0); }

// zruen poloky s danm indexem (implicitn 1 poloka)
	void Delete(int nIndex, int nCount = 1);
};
