
/////////////////////////////////////////////////////////////////////////////
// CEditSprite dialog

class CEditSprite : public CDialog
{
// Construction
public:
	CEditSprite(CWnd* pParent = NULL);   // standard constructor
	virtual ~CEditSprite();

// Dialog Data
	//{{AFX_DATA(CEditSprite)
	enum { IDD = IDD_EDIT_SPRITE };
	CScrollBar			m_HScroll;
	CScrollBar			m_VScroll;
	//}}AFX_DATA

	CSpriteBuf*	m_Sprite;			// buffer sprajt
	CIconBuf*	m_Icon;				// buffer ikon
	CMapBuf*	m_Map;				// buffer map

	BOOL	m_FilEdit;				// probh plnn editanch pol

// primrn parametry sprajtu
	int		m_Index;				// index editovanho sprajtu
//	SPRITE*	m_Data;					// ukazatel na data sprajtu
	int		m_Width;				// poet fz sprajtu
	int		m_Height;				// poet smr sprajtu
	int		m_IconWidth;			// ka ikony (bod)
	int		m_IconHeight;			// vka ikony (bod)
	int		m_IconSize;				// velikost ikony (bajt)

// uivatelem nastaven potek zobrazen plochy
	int		m_tLeft;				// poten bod plochy vlevo
	int		m_tTop;					// poten bod plochy nahoe

// rozmry plochy v bodech celkem
	int		m_mWidth;				// ka editovan plochy celkem (v bodech)
	int		m_mHeight;				// vka editovan plochy celkem (v bodech)

// souadnice klientsk oblasti pro plochu
	int		m_cWidth;				// ka klientsk oblasti pro editovanou plochu
	int		m_cHeight;				// vka klientsk oblasti pro editovanou plochu

// skuten zobrazen st plochy v bodech
	int		m_dWidth;				// ka zobrazen sti plochy v bodech
	int		m_dHeight;				// vka zobrazen sti plochy v bodech
	int		m_dLeft;				// lev potek zobrazen sti plochy
	int		m_dTop;					// horn potek zobrazen sti plochy

// skuten zobrazen st plochy v ikonch (okrajov ikony mohou bt zobrazeny nepln)
	int		m_iLeft;				// lev prvn zobrazen ikona (i necel)
	int		m_iTop;					// horn posledn zobrazen ikona (i necel)
	int		m_iRight;				// prav posledn zobrazen ikona (i necel)
	int		m_iBottom;				// spodn prvn zobrazen ikona (i necel)

// nepln zobrazen okrajovch ikon (rozsah 1 a m_IconWidth,m_IconHeight)
	int		m_oLeft;				// poet bod ikony vlevo
	int		m_oTop;					// poet bod ikony nahoe
	int		m_oRight;				// poet bod ikony vpravo
	int		m_oBottom;				// poet bod ikony dole

// posuvnky
	BOOL	m_HScrollDisp;			// horizontln posuvnk zapnut
	BOOL	m_VScrollDisp;			// vertikln posuvnk zapnut

	int		m_X;					// aktuln souadice kurzoru myi (v ikonch)
	int		m_Y;					// aktuln souadice kurzoru myi (v ikonch)

// obsluha taen
	BOOL	m_BegDrag;				// je mon zahjen taen
	int		m_BegX;					// poten souadnice kurzoru myi X ped taenm
	int		m_BegY;					// poten souadnice kurzoru myi Y ped taenm
	BOOL	m_Copy;					// pznak mdu kopie (prav tlatko)
	BOOL	m_Draging;				// zahjen md taen
	int		m_DragX;				// taen prvek - souadnice X
	int		m_DragY;				// taen prvek - souadnice Y
	CSize	m_HotSpot;				// bod uchycen taenho prvku
	CIconBuf	m_DragIcon;			// buffer taen ikony
	CImageList*	m_DragList;			// seznam obrzk pro taen

	HCURSOR		m_CurAkt;			// aktivn kurzor
	HCURSOR		m_CurArrow;			// standardn kurzor ipky (IDC_ARROW)
	HCURSOR		m_CurSelect;		// kurzor pro vbr
	HCURSOR		m_CurSelMove;		// kurzor - pesun vbru
	HCURSOR		m_CurCopy;			// kurzor koprovn
	HCURSOR		m_CurMove;			// kurzor pesunu
	HCURSOR		m_CurDelete;		// taen se zruenm
	HCURSOR		m_CurNoDrag;		// zkaz taen
	HCURSOR		m_CurCil;			// cl pi testu

// testovac md
	BOOL		m_TestMode;			// je testovac md
	BYTE*		m_TestData;			// vstupn bitmapa (NULL=nen)
//	MAP*		m_TestMap;			// adresa mapy

	int			m_TestLeft;			// lev okraj pole
	int			m_TestTop;			// horn okraj pole
	int			m_TestWidthN;		// ka pole v ikonch
	int			m_TestHeightN;		// vka pole v ikonch
	int			m_TestWidth;		// ka pole v bodech
	int			m_TestHeight;		// vka pole v bodech

	int			m_TestSrcX;			// vchoz polko objektu X
	int			m_TestSrcY;			// vchoz polko objektu Y
	int			m_TestDstX;			// clov polko objektu X
	int			m_TestDstY;			// clov polko objektu Y
	int			m_TestNextX;		// pt clov polko X
	int			m_TestNextY;		// pt clov polko Y

	BOOL		m_TestMove;			// pznak pohybu objektu
	double		m_TestX;			// skuten bodov souadnice X
	double		m_TestY;			// skuten bodov souadnice Y
	double		m_TestDX;			// prustek bodov souadnice X
	double		m_TestDY;			// prustek bodov souadnice Y
	int			m_TestFaze;			// aktuln fze
	int			m_TestSmer;			// aktuln smr
	int			m_TestKrok;			// ta fz pro jeden pohyb
	
	int			m_TimerID;			// ID asovae (0 = nen)
	int			m_Timer;			// ta asovae pro dal krok


	void BegEdit(int Index);
	void Recalc();
	void DispFazeSmer();
	void OnSetSpriteFaze();
	void OnSetSpriteSmer();
	void SetScroll();
	void DragDrop(int item);
	void EndDrag();
	void EndTest();
	void BegTest();
	void TestRepaint();
	void TestPut();

	void SetSpriteParam();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CEditSprite)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
public:

	// Generated message map functions
	//{{AFX_MSG(CEditSprite)
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnPaint();
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonDblClk(UINT nFlags, CPoint point);
	afx_msg void OnRButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnRButtonDblClk(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg BOOL OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message);
	afx_msg void OnRButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnClose();
	afx_msg void OnTimer(UINT nIDEvent);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//void CALLBACK EXPORT CallbackTimer(HWND hWnd, UINT nMsg, UINT nIDEvent, DWORD dwTime);
