// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "Peter.h"

#include "Select.h"
#include "IconBuf.h"
#include "TextBuf.h"
#include "RealBuf.h"
#include "BoolBuf.h"
#include "MapBuf.h"
#include "SprtBuf.h"
#include "SndBuf.h"
#include "ProgBuf.h"
#include "EditDial.h"
#include "EditSprt.h"
#include "EditIcon.h"
#include "EditMap.h"
#include "EditSnd.h"
#include "Prog.h"
#include "MainFrm.h"
#include "Exec.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


#define	TEXTBOX_HEIGHT	18			// vka textovho pole
#define	EDITBOX_HEIGHT	18			// vka editanho pole


// definice editanho pole v panelu vlastnost
//#define	EDITBOX_INDEX	4			// index editanho pole
//#define	EDITBOX_WIDTH	10*16		// ka editanho pole
//#define	EDITBOX_HEIGHT	18			// vka editanho pole

// definice editanho pole textu k hledn
//#define	FINDBOX_INDEX	0			// index editanho pole
//#define	FINDBOX_WIDTH	6*16		// ka editanho pole
//#define	FINDBOX_HEIGHT	18			// vka editanho pole

// definice textovho pole k zobrazen referenc
//#define	REFBOX_INDEX	5			// index referennho pole
//#define REFBOX_WIDTH	2*16		// ka referennho pole
//#define REFBOX_HEIGHT	18			// vka referennho pole

// definice textovho pole k zobrazen souadnic editoru ikony
//#define	ICONBOX_INDEX	18			// index referennho pole
//#define ICONBOX_WIDTH	3*16		// ka referennho pole
//#define ICONBOX_HEIGHT	18			// vka referennho pole

// definice pol v panelu plochy
//#define MAP_INDEX		0			// poten index pol
//#define MAPTEXT_WIDTH	2*16		// ka textu
//#define MAPTEXT_HEIGHT	18			// vka textu
//#define MAPEDIT_WIDTH	3*16		// ka editace
//#define MAPEDIT_HEIGHT	18			// vka editace
//#define MAPXY_WIDTH		4*16		// ka textu souadnic
//#define MAPXY_HEIGHT	18			// vka textu souadnic

// definice pol v panelu sprajtu
//#define SPRITE_INDEX		0			// poten index pol
//#define SPRITETEXT_WIDTH	3*16		// ka textu
//#define SPRITETEXT_HEIGHT	18			// vka textu
//#define SPRITEEDIT_WIDTH	2*16+8		// ka editace
//#define SPRITEDELAY_WIDTH	3*16		// ka editace prodlevy
//#define SPRITEEDIT_HEIGHT	18			// vka editace

#define TOOLSPACE		2			// mezera mezi toolbar

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_COMMAND(IDR_EXEC, OnExec)
	ON_COMMAND(IDR_SELECT, OnSelect)
	ON_COMMAND(ID_START, OnStart)
	ON_COMMAND(ID_STOP, OnStop)
	ON_COMMAND(ID_FILE_OPEN2, OnFileOpen)
	ON_COMMAND(ID_FILE_CLOSE2, OnFileClose)
	ON_COMMAND(IDR_PROG, OnProg)
	ON_WM_CLOSE()
	ON_WM_SHOWWINDOW()
	ON_COMMAND(ID_FILE_NEW2, OnFileNew2)
	ON_UPDATE_COMMAND_UI(IDC_EDITICON_PEN, OnUpdateEditiconPen)
	ON_UPDATE_COMMAND_UI(IDC_EDITICON_ELIP, OnUpdateEditiconElip)
	ON_UPDATE_COMMAND_UI(IDC_EDITICON_FILL, OnUpdateEditiconFill)
	ON_UPDATE_COMMAND_UI(IDC_EDITICON_LINE, OnUpdateEditiconLine)
	ON_UPDATE_COMMAND_UI(IDC_EDITICON_PAINT, OnUpdateEditiconPaint)
	ON_UPDATE_COMMAND_UI(IDC_EDITICON_PIPE, OnUpdateEditiconPipe)
	ON_UPDATE_COMMAND_UI(IDC_EDITICON_RECT, OnUpdateEditiconRect)
	ON_UPDATE_COMMAND_UI(IDC_EDITICON_ROUND, OnUpdateEditiconRound)
	ON_UPDATE_COMMAND_UI(IDC_EDITICON_SELECT, OnUpdateEditiconSelect)
	ON_UPDATE_COMMAND_UI(IDC_EDITICON_SPRAY, OnUpdateEditiconSpray)
	ON_UPDATE_COMMAND_UI(IDC_EDITICON_XFLIP, OnUpdateEditiconXFlip)
	ON_UPDATE_COMMAND_UI(IDC_EDITICON_YFLIP, OnUpdateEditiconYFlip)
	ON_UPDATE_COMMAND_UI(IDC_EDITICON_RROT, OnUpdateEditiconRRot)
	ON_UPDATE_COMMAND_UI(IDC_EDITICON_LROT, OnUpdateEditiconLRot)
	ON_UPDATE_COMMAND_UI(IDC_EDITICON_XCOL, OnUpdateEditiconXCol)
	ON_COMMAND(IDC_EDITICON_ELIP, OnEditiconElip)
	ON_COMMAND(IDC_EDITICON_FILL, OnEditiconFill)
	ON_COMMAND(IDC_EDITICON_LINE, OnEditiconLine)
	ON_COMMAND(IDC_EDITICON_PAINT, OnEditiconPaint)
	ON_COMMAND(IDC_EDITICON_PEN, OnEditiconPen)
	ON_COMMAND(IDC_EDITICON_PIPE, OnEditiconPipe)
	ON_COMMAND(IDC_EDITICON_RECT, OnEditiconRect)
	ON_COMMAND(IDC_EDITICON_ROUND, OnEditiconRound)
	ON_COMMAND(IDC_EDITICON_SELECT, OnEditiconSelect)
	ON_COMMAND(IDC_EDITICON_SPRAY, OnEditiconSpray)
	ON_COMMAND(IDC_EDITICON_XFLIP, OnEditiconXFlip)
	ON_COMMAND(IDC_EDITICON_YFLIP, OnEditiconYFlip)
	ON_COMMAND(IDC_EDITICON_RROT, OnEditiconRRot)
	ON_COMMAND(IDC_EDITICON_LROT, OnEditiconLRot)
	ON_COMMAND(IDC_EDITICON_XCOL, OnEditiconXCol)
	//}}AFX_MSG_MAP
	// Global help commands
	ON_COMMAND(ID_HELP_FINDER, CFrameWnd::OnHelpFinder)
	ON_COMMAND(ID_HELP, CFrameWnd::OnHelp)
	ON_COMMAND(ID_CONTEXT_HELP, CFrameWnd::OnContextHelp)
	ON_COMMAND(ID_DEFAULT_HELP, CFrameWnd::OnHelpFinder)
//	ON_NOTIFY(NM_KILLFOCUS, IDC_EDITMAP_SIRKA_EDIT, OnKillFocusSirkaMap)
END_MESSAGE_MAP()

static UINT StatSelect[] =
{
	ID_SEPARATOR,           // status line indicator
};

static UINT StatProg[] =
{
	ID_SEPARATOR,           // status line indicator
//	ID_INDICATOR_POS,
//	ID_INDICATOR_OVR,
};

static UINT StatExec[] =
{
	ID_SEPARATOR,           // status line indicator
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	m_Page = PageNone;
//	m_PageExec = PageSelect;
}

CMainFrame::~CMainFrame()
{
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
// nastaven rozmr a pozice hlavnho okna
	RECT rc;
	rc.left = (ScreenWidth*MainLeft+Scale/2)/Scale;
	rc.top = (ScreenHeight*MainTop+Scale/2)/Scale;
	rc.right = rc.left + (ScreenWidth*MainWidth+Scale/2)/Scale;
	rc.bottom = rc.top + (ScreenHeight*MainHeight+Scale/2)/Scale;
	if (rc.right < 30) rc.right = 30;
	if (rc.left > ScreenWidth-30) rc.left = ScreenWidth-30;
	if (rc.top > ScreenHeight-30) rc.top = ScreenHeight-30;
	MoveWindow(&rc, FALSE);

	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;

// vytvoen panel nstroj
	CreateToolBar(m_wndToolBar,		IDR_SELECT,		_T("Program"));
	CreateToolBar(m_wndEdiBar,		IDR_EDIT,		_T("pravy"));
	CreateToolBar(m_wndIconBar,		IDR_EDITICON,	_T("Obrzek"));
	CreateToolBar(m_wndMapBar,		IDR_EDITMAP,	_T("Plocha"));
	CreateToolBar(m_wndSpriteBar,	IDR_EDITSPRITE,	_T("Sprajt"));
	CreateToolBar(m_wndPropBar,		IDR_PROP,		_T("Vlastnosti"));
	CreateToolBar(m_wndNavBar,		IDR_NAVIG,		_T("Navigace"));
	CreateToolBar(m_wndSoundBar,	IDR_EDITSOUND,	_T("Zvuk"));

// panel editace ikon
	m_wndIconBar.SetButtonInfo(17, 0, TBBS_SEPARATOR, 1);
	CreateXYBox(m_wndIconBar, m_IconBox, 18, IDC_EDITICON_XY, 6*8);
	m_wndIconBar.SetButtonInfo(19, 0, TBBS_SEPARATOR, 1);

// panel editace ploch
	CreateTextBox(m_wndMapBar, m_MapSirkaText, 0, IDC_EDITMAP_SIRKA_TEXT, 4*8, _T("ka"));
	CreateEditBox(m_wndMapBar, m_MapSirkaEdit, 2, IDC_EDITMAP_SIRKA_EDIT, 6*8);
	CreateTextBox(m_wndMapBar, m_MapVyskaText, 4, IDC_EDITMAP_VYSKA_TEXT, 4*8, _T("vka"));
	CreateEditBox(m_wndMapBar, m_MapVyskaEdit, 6, IDC_EDITMAP_VYSKA_EDIT, 6*8);
	CreateXYBox(m_wndMapBar, m_MapXY, 8, IDC_EDITMAP_XY, 8*8);

// panel editace sprajtu
	CreateTextBox(m_wndSpriteBar, m_SpriteFazeText, 0, IDC_EDITSPRITE_FAZE_TEXT, 3*8, _T("fze"));
	CreateEditBox(m_wndSpriteBar, m_SpriteFazeEdit, 2, IDC_EDITSPRITE_FAZE_EDIT, 5*8);
	CreateTextBox(m_wndSpriteBar, m_SpriteSmerText, 4, IDC_EDITSPRITE_SMER_TEXT, 4*8, _T("smry"));
	CreateEditBox(m_wndSpriteBar, m_SpriteSmerEdit, 6, IDC_EDITSPRITE_SMER_EDIT, 5*8);
	CreateXYBox(m_wndSpriteBar, m_SpriteXY, 8, IDC_EDITSPRITE_XY, 6*8);
	CreateTextBox(m_wndSpriteBar, m_SpriteDelayText, 10, IDC_EDITSPRITE_DELAY_TEXT, 5*8, _T("prodleva"));
	CreateEditBox(m_wndSpriteBar, m_SpriteDelayEdit, 12, IDC_EDITSPRITE_DELAY_EDIT, 6*8);
	CreateTextBox(m_wndSpriteBar, m_SpriteKrokText, 14, IDC_EDITSPRITE_KROK_TEXT, 3*8, _T("krok"));
	CreateEditBox(m_wndSpriteBar, m_SpriteKrokEdit, 16, IDC_EDITSPRITE_KROK_EDIT, 5*8);

// panel vlastnost
	CreateEditBox(m_wndPropBar, m_NameBox, 4, IDC_PROG_EDIT, 20*8);

// panel navigace
	CreateEditBox(m_wndNavBar, m_FindBox, 3, IDC_PROG_FIND, 12*8);
	m_wndNavBar.SetButtonInfo(7, 0, TBBS_SEPARATOR, 1);
	CreateXYBox(m_wndNavBar, m_RefBox, 8, IDC_PROG_REFER, 4*8);
	m_wndNavBar.SetButtonInfo(9, 0, TBBS_SEPARATOR, 1);

// stavov panel
	VERIFY(m_wndStatusBar.Create(this));
	VERIFY(m_wndStatusBar.SetIndicators(StatSelect, sizeof(StatSelect)/sizeof(UINT)));


// pepoet rozloen panel
	RecalcLayout();



	EnableDocking(CBRS_ALIGN_ANY);

	m_wndToolBar.SetBarStyle(m_wndToolBar.GetBarStyle() |
		CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC);
	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);
	RecalcLayout();

	CRect rect;

	m_wndToolBar.GetWindowRect(&rect);
	rect.OffsetRect(rect.right - rect.left + TOOLSPACE,0);
	m_wndEdiBar.SetBarStyle(m_wndEdiBar.GetBarStyle() |
		CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC);
	m_wndEdiBar.EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndEdiBar,(UINT)0,&rect);
	RecalcLayout();


	m_wndEdiBar.GetWindowRect(&rect);
	rect.OffsetRect(rect.right - rect.left + TOOLSPACE,0);
	m_wndPropBar.SetBarStyle(m_wndPropBar.GetBarStyle() |
		CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC);
	m_wndPropBar.EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndPropBar,(UINT)0,&rect);
	RecalcLayout();


	m_wndPropBar.GetWindowRect(&rect);
	rect.OffsetRect(rect.right - rect.left + TOOLSPACE,0);
	m_wndNavBar.SetBarStyle(m_wndNavBar.GetBarStyle() |
		CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC);
	m_wndNavBar.EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndNavBar,(UINT)0,&rect);
	RecalcLayout();

	m_wndNavBar.GetWindowRect(&rect);
	rect.OffsetRect(-rect.left + 200,rect.bottom - rect.top);
	m_wndIconBar.SetBarStyle(m_wndIconBar.GetBarStyle() |
		CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC);
	m_wndIconBar.EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndIconBar,(UINT)0,&rect);
	RecalcLayout();

//	m_wndIconBar.GetWindowRect(&rect);
//	rect.OffsetRect(rect.right - rect.left + TOOLSPACE,0);
	m_wndMapBar.SetBarStyle(m_wndMapBar.GetBarStyle() |
		CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC);
	m_wndMapBar.EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndMapBar,(UINT)0,&rect);
	RecalcLayout();

	m_wndSpriteBar.SetBarStyle(m_wndSpriteBar.GetBarStyle() |
		CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC);
	m_wndSpriteBar.EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndSpriteBar,(UINT)0,&rect);
	RecalcLayout();

	m_wndSoundBar.SetBarStyle(m_wndSoundBar.GetBarStyle() |
		CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC);
	m_wndSoundBar.EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndSoundBar,(UINT)0,&rect);
	RecalcLayout();


//	m_wndObjBar.GetWindowRect(&rect);
//	rect.OffsetRect(150,0);
//	m_wndStrucBar.SetBarStyle(m_wndStrucBar.GetBarStyle() |
//		CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC);
//	m_wndStrucBar.EnableDocking(CBRS_ALIGN_ANY);
//	DockControlBar(&m_wndStrucBar,(UINT)0,&rect);

//	RecalcLayout();


//	if (Maximized)
//		ShowWindow(SW_SHOWMAXIMIZED);


//	LoadBarState(_T("General"));

	return 0;
}

/////////////////////////////////////////////////////////////////////////////
// vytvoen panelu nstroj

void CMainFrame::CreateToolBar(CToolBar& bar, int id, CString text)
{
	VERIFY(bar.Create(this));
	VERIFY(bar.LoadToolBar(id));
	bar.SetWindowText(text);
}

/////////////////////////////////////////////////////////////////////////////
// vytvoen textovho pole pro zobrazen souadnic v panelu nstroj

void CMainFrame::CreateXYBox(CToolBar& bar, CStatic& box, int index, int id, int width)
{
	CRect rc(-width, -TEXTBOX_HEIGHT, 0, 0);
	VERIFY(box.Create(_T(""), WS_CHILD | SS_CENTER, rc, &bar, id));
	bar.SetButtonInfo(index, id, TBBS_SEPARATOR, width);
	bar.GetItemRect(index, rc);
	box.SetWindowPos(NULL, rc.left, rc.top+3, 0, 0,
		SWP_NOZORDER | SWP_NOACTIVATE|SWP_NOSIZE|SWP_NOCOPYBITS);
	box.ShowWindow(SW_SHOW);
}

/////////////////////////////////////////////////////////////////////////////
// vytvoen textovho pole v panelu nstroj

void CMainFrame::CreateTextBox(CToolBar& bar, CStatic& box, int index, int id, int width, CString text)
{
// vytvoen textovho pole
	CRect rc(-width, -TEXTBOX_HEIGHT, 0, 0);
	VERIFY(box.Create(text, WS_CHILD | SS_RIGHT, rc, &bar, id));

// nastaven fontu zobrazenho textu
	HFONT font = (HFONT)GetStockObject(DEFAULT_GUI_FONT);
	if (font == NULL)
		font = (HFONT)GetStockObject(ANSI_VAR_FONT);
	box.SendMessage(WM_SETFONT, (WPARAM)font);

// nastaven rozmr a pozice textovho pole
	bar.SetButtonInfo(index, id, TBBS_SEPARATOR, width);
	bar.GetItemRect(index, rc);
	box.SetWindowPos(NULL, rc.left, rc.top+3, 0, 0,
		SWP_NOZORDER | SWP_NOACTIVATE|SWP_NOSIZE|SWP_NOCOPYBITS);
	box.ShowWindow(SW_SHOW);
}

/////////////////////////////////////////////////////////////////////////////
// vytvoen editanho pole v panelu nstroj

void CMainFrame::CreateEditBox(CToolBar& bar, CEdit& box, int index, int id, int width)
{
// vytvoen editanho pole
	CRect rc(-width, -EDITBOX_HEIGHT, 0, 0);
	VERIFY(box.Create(WS_CHILD | ES_AUTOHSCROLL, rc, &bar, id));
	box.ModifyStyleEx(0,WS_EX_CLIENTEDGE,SWP_DRAWFRAME);

// nastaven fontu zobrazenho textu
	HFONT font = (HFONT)GetStockObject(DEFAULT_GUI_FONT);
	if (font == NULL)
		font = (HFONT)GetStockObject(ANSI_VAR_FONT);
	box.SendMessage(WM_SETFONT, (WPARAM)font);

// nastaven rozmr a pozice editanho pole
	bar.SetButtonInfo(index, id, TBBS_SEPARATOR, width);
	bar.GetItemRect(index, rc);
	box.SetWindowPos(NULL, rc.left, rc.top+2, 0, 0,
		SWP_NOZORDER | SWP_NOACTIVATE|SWP_NOSIZE|SWP_NOCOPYBITS);
	box.ShowWindow(SW_SHOW);
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// nastaven nov strnky

void CMainFrame::OnSelect() 
{
	SetPage(PageSelect);
}

void CMainFrame::OnExec() 
{
//	SetPage(PageExec);
}

void CMainFrame::OnProg() 
{
	SetPage(PageProg);
}

void CMainFrame::OnStop() 
{
//	SetPage(m_PageExec);
}

void CMainFrame::SetPage(Pages page)
{
// pokraovat, jen je-li strnka opravdu zmnna
	if (page == m_Page) return;

	CView* pOldActiveView = GetActiveView();

	CRuntimeClass* pNewViewClass;
	int resID;

// pprava definice nov strnky
	switch (page)
	{
	case PageSelect:
		pNewViewClass = RUNTIME_CLASS(CSelect);
		resID = IDR_SELECT;
		m_wndStatusBar.SetIndicators(StatSelect,
		  sizeof(StatSelect)/sizeof(UINT));
		ShowControlBar(&m_wndEdiBar,FALSE,TRUE);
		ShowControlBar(&m_wndPropBar,FALSE,TRUE);
		ShowControlBar(&m_wndNavBar,FALSE,TRUE);
		ShowControlBar(&m_wndIconBar,FALSE,TRUE);
		ShowControlBar(&m_wndMapBar,FALSE,TRUE);
		ShowControlBar(&m_wndSpriteBar,FALSE,TRUE);
		ShowControlBar(&m_wndSoundBar,FALSE,TRUE);
	
		break;

	case PageProg:
		pNewViewClass = RUNTIME_CLASS(CProg);
		resID = IDR_PROG;
		m_wndStatusBar.SetIndicators(StatProg,
		  sizeof(StatProg)/sizeof(UINT));
		ShowControlBar(&m_wndEdiBar,TRUE,TRUE);
		ShowControlBar(&m_wndPropBar,TRUE,TRUE);
		ShowControlBar(&m_wndNavBar,TRUE,TRUE);
		ShowControlBar(&m_wndIconBar,FALSE,TRUE);
		ShowControlBar(&m_wndMapBar,FALSE,TRUE);
		ShowControlBar(&m_wndSpriteBar,FALSE,TRUE);
		ShowControlBar(&m_wndSoundBar,FALSE,TRUE);
		break;
	
	default:
		return;
	}

// naten nstrojovho panelu
	m_wndToolBar.LoadToolBar(resID);

// naten tabulky akcelertor
	m_hAccelTable = NULL;
	LoadAccelTable(MAKEINTRESOURCE(resID));

// naten hlavnho menu
	HMENU hMenu;
	hMenu = ::GetMenu(m_hWnd);
	HMENU hMenuN;
	hMenuN = ::LoadMenu(AfxGetApp()->m_hInstance,MAKEINTRESOURCE(resID));
	if (hMenuN != NULL)
	{
		if (hMenu != NULL) 
			::DestroyMenu(hMenu);
		::SetMenu(m_hWnd,hMenuN);
		m_hMenuDefault = hMenuN;
	}

	m_Page = page;

	CCreateContext context;
	context.m_pNewViewClass = pNewViewClass;
	context.m_pCurrentDoc = GetActiveDocument();
	CView* pNewView = STATIC_DOWNCAST(CView, CreateView(&context));
	if (pNewView != NULL)
	{
		pNewView->ShowWindow(SW_SHOW);
		pNewView->OnInitialUpdate();
		SetActiveView(pNewView);
		RecalcLayout();
		pOldActiveView->DestroyWindow();
	}
}


void CMainFrame::OnFileClose() 
{
	OnSelect();	
}

void CMainFrame::OnStart() 
{
	OnExec();
}

void CMainFrame::OnFileOpen() 
{
	OnProg();	
}

void CMainFrame::OnClose() 
{
//	SaveBarState(_T("General"));

// schova rozmr hlavnho okna
	WINDOWPLACEMENT wp;
	GetWindowPlacement(&wp);
	RECT rc = wp.rcNormalPosition;

	MainLeft = (rc.left*Scale+ScreenWidth/2)/ScreenWidth;
	MainTop = (rc.top*Scale+ScreenHeight/2)/ScreenHeight;
	MainWidth = ((rc.right-rc.left)*Scale+ScreenWidth/2)/ScreenWidth;
	MainHeight = ((rc.bottom-rc.top)*Scale+ScreenHeight/2)/ScreenHeight;

	Maximized = IsZoomed();

	CFrameWnd::OnClose();
}


void CMainFrame::OnShowWindow(BOOL bShow, UINT nStatus) 
{
	CFrameWnd::OnShowWindow(bShow, nStatus);

	if (Maximized && bShow)
		ShowWindow(SW_SHOWMAXIMIZED);
}


void CMainFrame::OnFileNew2() 
{
	
}


BOOL CMainFrame::PreTranslateMessage(MSG* pMsg) 
{
	if (pMsg->message == WM_KEYDOWN)
	{
		if ((pMsg->wParam == VK_RETURN) || (pMsg->wParam == VK_TAB) || (pMsg->wParam == VK_ESCAPE))
		{
			CWnd* wnd = GetFocus();
			if (wnd != NULL)
			{
				if (wnd->m_hWnd == m_NameBox.m_hWnd)
				{
					if (Prog != NULL)
						Prog->m_Buf[Prog->m_AktBufID].m_Tree->SetFocus();
					return TRUE;
				}

// vka a ka mapy
				if (wnd->m_hWnd == m_MapSirkaEdit.m_hWnd)
				{
					if (Prog != NULL)
					{
						Prog->m_Buf[Prog->m_AktBufID].m_Tree->SetFocus();
						if (pMsg->wParam == VK_RETURN)
							Prog->m_ProgMap.OnSetMapSirka();
						else
							Prog->m_ProgMap.DispSirkaVyska();
					}
					return TRUE;
				}

				if (wnd->m_hWnd == m_MapVyskaEdit.m_hWnd)
				{
					if (Prog != NULL)
					{
						Prog->m_Buf[Prog->m_AktBufID].m_Tree->SetFocus();
						if (pMsg->wParam == VK_RETURN)
							Prog->m_ProgMap.OnSetMapVyska();
						else
							Prog->m_ProgMap.DispSirkaVyska();
					}
					return TRUE;
				}

// editor sprajtu
				if (wnd->m_hWnd == m_SpriteFazeEdit.m_hWnd)
				{
					if (Prog != NULL)
					{
						Prog->m_Buf[Prog->m_AktBufID].m_Tree->SetFocus();
						if (pMsg->wParam == VK_RETURN)
							Prog->m_ProgSprite.OnSetSpriteFaze();
						else
							Prog->m_ProgSprite.DispFazeSmer();
					}
					return TRUE;
				}

				if (wnd->m_hWnd == m_SpriteSmerEdit.m_hWnd)
				{
					if (Prog != NULL)
					{
						Prog->m_Buf[Prog->m_AktBufID].m_Tree->SetFocus();
						if (pMsg->wParam == VK_RETURN)
							Prog->m_ProgSprite.OnSetSpriteSmer();
						else
							Prog->m_ProgSprite.DispFazeSmer();
					}
					return TRUE;
				}

				if ((wnd->m_hWnd == m_SpriteDelayEdit.m_hWnd) ||
					(wnd->m_hWnd == m_SpriteKrokEdit.m_hWnd))
				{
					if (Prog != NULL)
					{
						Prog->m_Buf[Prog->m_AktBufID].m_Tree->SetFocus();
						Prog->m_ProgSprite.DispFazeSmer();
					}
					return TRUE;
				}


// hledan text
				if (wnd->m_hWnd == m_FindBox.m_hWnd)
				{
					if (Prog != NULL)
					{
						Prog->m_Buf[Prog->m_AktBufID].m_Tree->SetFocus();
						if (pMsg->wParam == VK_RETURN)
							Prog->OnFindNext();
					}
					return TRUE;
				}
			}
		}
	}
	
	return CFrameWnd::PreTranslateMessage(pMsg);
}


/////////////////////////////////////////////////////////////////////////////
// panel nstroj editoru

void CMainFrame::OnUpdateEditiconElip(CCmdUI* pCmdUI) 
	{ OnUpdateEditicon(pCmdUI, EditModeElip); }

void CMainFrame::OnUpdateEditiconFill(CCmdUI* pCmdUI) 
	{ OnUpdateEditicon(pCmdUI, EditModeFill); }

void CMainFrame::OnUpdateEditiconLine(CCmdUI* pCmdUI) 
	{ OnUpdateEditicon(pCmdUI, EditModeLine); }

void CMainFrame::OnUpdateEditiconPaint(CCmdUI* pCmdUI) 
	{ OnUpdateEditicon(pCmdUI, EditModePaint); }

void CMainFrame::OnUpdateEditiconPen(CCmdUI* pCmdUI) 
	{ OnUpdateEditicon(pCmdUI, EditModePen); }

void CMainFrame::OnUpdateEditiconPipe(CCmdUI* pCmdUI) 
	{ OnUpdateEditicon(pCmdUI, EditModePipe); }

void CMainFrame::OnUpdateEditiconRect(CCmdUI* pCmdUI) 
	{ OnUpdateEditicon(pCmdUI, EditModeRect); }

void CMainFrame::OnUpdateEditiconRound(CCmdUI* pCmdUI) 
	{ OnUpdateEditicon(pCmdUI, EditModeRound); }

void CMainFrame::OnUpdateEditiconSelect(CCmdUI* pCmdUI) 
	{ OnUpdateEditicon(pCmdUI, EditModeSelect); }

void CMainFrame::OnUpdateEditiconSpray(CCmdUI* pCmdUI) 
	{ OnUpdateEditicon(pCmdUI, EditModeSpray); }

void CMainFrame::OnUpdateEditiconXFlip(CCmdUI* pCmdUI) 
	{ OnUpdateEditicon(pCmdUI, EditModeXFlip); }

void CMainFrame::OnUpdateEditiconYFlip(CCmdUI* pCmdUI) 
	{ OnUpdateEditicon(pCmdUI, EditModeYFlip); }

void CMainFrame::OnUpdateEditiconRRot(CCmdUI* pCmdUI) 
	{ OnUpdateEditicon(pCmdUI, EditModeRRot); }

void CMainFrame::OnUpdateEditiconLRot(CCmdUI* pCmdUI) 
	{ OnUpdateEditicon(pCmdUI, EditModeLRot); }

void CMainFrame::OnUpdateEditiconXCol(CCmdUI* pCmdUI) 
	{ OnUpdateEditicon(pCmdUI, EditModeXCol); }

void CMainFrame::OnUpdateEditicon(CCmdUI* pCmdUI, int mode) 
{
	if (Prog != NULL)
		if (Prog->m_ProgPic.m_EditMode == mode)
			pCmdUI->SetCheck(1);
		else
			pCmdUI->SetCheck(0);
}

void CMainFrame::OnEditiconElip() 
	{ OnEditicon(EditModeElip); }

void CMainFrame::OnEditiconFill() 
	{ OnEditicon(EditModeFill); }

void CMainFrame::OnEditiconLine() 
	{ OnEditicon(EditModeLine); }

void CMainFrame::OnEditiconPaint() 
	{ OnEditicon(EditModePaint); }

void CMainFrame::OnEditiconPen() 
	{ OnEditicon(EditModePen); }

void CMainFrame::OnEditiconPipe() 
	{ OnEditicon(EditModePipe); }

void CMainFrame::OnEditiconRect() 
	{ OnEditicon(EditModeRect); }

void CMainFrame::OnEditiconRound() 
	{ OnEditicon(EditModeRound); }

void CMainFrame::OnEditiconSelect() 
	{ OnEditicon(EditModeSelect); }

void CMainFrame::OnEditiconSpray() 
	{ OnEditicon(EditModeSpray); }

void CMainFrame::OnEditiconXFlip() 
	{ OnEditicon(EditModeXFlip); }

void CMainFrame::OnEditiconYFlip() 
	{ OnEditicon(EditModeYFlip); }

void CMainFrame::OnEditiconRRot() 
	{ OnEditicon(EditModeRRot); }

void CMainFrame::OnEditiconLRot() 
	{ OnEditicon(EditModeLRot); }

void CMainFrame::OnEditiconXCol() 
	{ OnEditicon(EditModeXCol); }

void CMainFrame::OnEditicon(int mode) 
{
	if (Prog != NULL)
		Prog->m_ProgPic.SetEditMode(mode);
}

//void CMainFrame::OnKillFocusSirkaMap(NMHDR* pNMHDR, LRESULT* pResult)
//{
//	
//	*pResult = 0;
//}

