
#include "stdafx.h"
#include "peter.h"
#include "RealBuf.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define REALREZERVA 100			// rezerva pi zvtovn bufferu

////////////////////////////////////////////////////////////////////
// konstruktor a destruktor

CRealBuf::CRealBuf()
{
	m_Data = NULL;
	m_Num = 0;				// nen dn prvek
	m_Max = 0;				// maximln velikost
}

CRealBuf::~CRealBuf()
{
	Aloc(m_Data, 0);			// zruen bufferu
}


////////////////////////////////////////////////////////////////////
// nastaven nov velikosti bufferu

void CRealBuf::SetSize(int nNewSize)
{
// oprava poadovan velikosti
//	if (nNewSize < 0)			// je velikost zporn ?
//		nNewSize = 0;			// oprava daje

// test, zda je zvten bufferu
	if (nNewSize > m_Max)
	{

// nastaven nov velikosti bufferu
		m_Max = nNewSize + REALREZERVA;	// nov velikost bufferu

// vytvoen novho bufferu
		Aloc(m_Data, m_Max * sizeof(double));
	}

// nov poet poloek
	m_Num = nNewSize;
}


////////////////////////////////////////////////////////////////////
// zruen poloky s danm indexem (implicitn 1 poloka)

void CRealBuf::Delete(int nIndex, int nCount)
{
// korekce indexu
	if (nIndex >= m_Num)
		nIndex = m_Num-1;		// maximln hodnota indexu
	if (nIndex < 0)
		nIndex = 0;				// minimln hodnota indexu

// korekce potu poloek ke zruen
	if (nIndex + nCount > m_Num)
		nCount = m_Num - nIndex;

// kontrola, zda je co ruit
	if (nCount <= 0)
		return;

// psun zbylch poloek
	if (m_Num > (nIndex + nCount))
		memmove(&m_Data[nIndex], &m_Data[nIndex + nCount],
			(m_Num - (nIndex + nCount)) * sizeof(double));

// zmna potu poloek
	m_Num -= nCount;
}

