// SprtPar.cpp : implementation file
//

#include "stdafx.h"
#include "peter.h"
#include "SprtPar.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// SpritePar dialog


CSpritePar::CSpritePar(CWnd* pParent)
	: CDialog(CSpritePar::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSpritePar)
	m_FazeText = _T("");
	m_KlidText = _T("");
	m_SmerText = _T("");
	m_DelayText = _T("");
	m_KrokText = _T("");
	m_LevelText = _T("");
	//}}AFX_DATA_INIT
}


void CSpritePar::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSpritePar)
	DDX_Text(pDX, IDC_SPRITE_PARAM_FAZE, m_FazeText);
	DDX_Text(pDX, IDC_SPRITE_PARAM_KLID, m_KlidText);
	DDX_Text(pDX, IDC_SPRITE_PARAM_SMER, m_SmerText);
	DDX_Text(pDX, IDC_SPRITE_PARAM_DELAY, m_DelayText);
	DDX_Text(pDX, IDC_SPRITE_PARAM_KROK, m_KrokText);
	DDX_Text(pDX, IDC_SPRITE_PARAM_LEVEL, m_LevelText);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSpritePar, CDialog)
	//{{AFX_MSG_MAP(CSpritePar)
	ON_EN_KILLFOCUS(IDC_SPRITE_PARAM_FAZE, OnKillfocusSpriteParamFaze)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


BOOL CSpritePar::OnInitDialog() 
{
	SetData();

	CDialog::OnInitDialog();
	return TRUE;
}


void CSpritePar::OnKillfocusSpriteParamFaze() 
{

}

void CSpritePar::SetData()
{
	m_FazeText.Format("%d", m_Faze);
	m_KlidText.Format("%d", m_Klid);
	m_SmerText.Format("%d", m_Smer);
	m_DelayText.Format("%d", m_Delay);
	m_KrokText.Format("%.f", m_Krok);
	m_LevelText.Format("%d", m_Level);

	UpdateData(FALSE);	
}


void CSpritePar::GetData()
{
	UpdateData(TRUE);


}
